* Emulates FoxPro DIR and DIRECTORY, see stdfoxpro.fh
* Copyright (c) 1999 by multisoft GmbH
*
* Compile: FlagShip [-na] -c -m foxdir.prg
*     and link the foxdir.o with your source
*
FUNCTION foxdir (cDrive, cPath, cFile, lPrint, cOutFile)

local cPattern := "", cDisk
local aDir, ii, nRecords, nSpace
local saveCons := set(_SET_CONSOLE)
local savePrint:= set(_SET_PRINTER)
local savePrFil:= set(_SET_PRINTFILE)

lPrint := if(valtype(lPrint) == "L", lPrint, .F.) 
if !empty(cDrive) .and. valtype(cDrive) == "C"
   cPattern += alltrim(cDrive)
endif
if !empty(cPath) .and. valtype(cPath) == "C"
   cPattern += alltrim(cPath)
endif
cDisk := cPattern
if !empty(cPattern)
   if(! (right(cPattern,1) $ "/\"))
      cPattern += "/"
   endif
endif
if !empty(cFile) .and. valtype(cFile) == "C"
   cPattern += alltrim(cFile)
else
   cPattern += "*.dbf"
endif

dbCommitAll()  // ensure dbf's are flushed

aDir := directory(cPattern)

if lPrint .or. !empty(cOutFile)
   SET CONSOLE OFF
   if !empty(cOutFile)
      SET PRINTER TO (alltrim(cOutFile)) ADDITIVE
   endif
   SET PRINTER ON
endif

for ii := 1 to len(aDir)
   ? padr(aDir[ii,1],14)
   if lower(right(aDir[ii,1],4)) == ".dbf"
      nRecords :=getDbfRecords(aDir[ii,1])
      ?? " " + ltrim(nRecords) + " records,"
   endif
   ?? " file size = " + ltrim(aDir[ii,2]) + ;
      " bytes, modified on", aDir[ii,3], aDir[ii,4]
next
?
? "Space available on " 
if empty(cDisk)
   nSpace := diskspace()
   ?? curdir() + " = " + ltrim(nSpace)
else
   nSpace := diskspace(cDisk)
   ?? cDisk + " = " + ltrim(nSpace)
endif
?? " bytes = " + ltrim(str(nSpace / 1048575,10,3)) + " MB"
?

if lPrint .or. !empty(cOutFile)
   SET PRINTER OFF
endif

set(_SET_CONSOLE, saveCons)
set(_SET_PRINTER, savePrint)
set(_SET_PRINTFILE, savePrFil)

return NIL

// reads number of records directly from the .dbf file
//
STATIC FUNCT getDbfRecords (cFile)
local fd, buff := space(4)
if !file(cFile)
   return -1
endif
fd := fopen(cFile, 0)
if fd < 1
   return -1
endif
fseek(fd, 4, 0)
fread(fd, @buff, 4)
fclose(fd)
return bin2l(buff)

* eof 
