* Restore previous FoxPro arrays to new one
* Copyright (c) 1999 by multisoft GmbH
*
* Compile: FlagShip [-na] -c -m foxrestarr.prg
*     and link the foxrestarr.o with your source
*

FUNCTION foxRestArr(aNew, aOld)
//
// aNew  : new array, will be pre-filled with .F. instead of NIL
// aOld  : optional. If given, fill the elements of this array 
//         sequentially to <aNew> 
// return: NIL on error, otherwise a pointer to <aNew>. 
//         Since the <aNew> is passed by reference, and therefore
//         changed in-place, the return value may be ignored.

local iDim1 := 0, iDim2 := 0, ii, jj, pos := 0
local aTmp := {}
 
if !(valtype(aNew) == "A")
   return NIL
endif

// default = .F. for FoxPro instead of NIL in FlagShip and Clipper
//
iDim1 := len(aNew)
for ii := 1 to iDim1
   if valtype(aNew[ii]) == "A"
      afill(aNew[ii], .F.)
   else
      aNew[ii] := .F.
   endif
next
if !(valtype(aOld) == "A")
   return aNew
endif

// create 1-dim array from aOld
//
iDim2 := len(aOld)
for ii := 1 to iDim2
   if valtype(aOld[ii]) == "A"
      for jj := 1 to len(aOld[ii])
         aadd(aTmp, aOld[ii,jj])  // only 2-dim supported by Fox
      next
   else
      aadd(aTmp, aOld[ii])
   endif
next

// store elements from <aOld> to <aNew> via the 1-dim array, 
// so the array structures may differ
//
pos := 0
for ii := 1 to iDim1
   if pos >= len(aTmp)
      return aNew
   endif
   if valtype(aNew[ii]) == "A"
      for jj := 1 to len(aNew[ii]) 
          if pos >= len(aTmp)
            return aNew
          endif
          aNew[ii,jj] := aTmp[++pos]
      next
   else
     aNew[ii] := aTmp[++pos]
   endif
next
return aNew   
      
