** simple test for the SmallRDD.PRG == smallRDD driver.
** Compile: FlagShip srddtest.prg smallrdd.o

extern smallRDDNew

set print on

if !file("srddtest.dbf")
   dbcreate ("srddtest.dbf",           ;
             {{"char1", "c",   5, 0},  ;
              {"char2", "c", 300, 0},  ;
              {"num1" , "n",   2, 0},  ;
              {"num2" , "n",  15, 3},  ;
              {"dat1" , "d",   8, 0},  ;
              {"log1" , "l",   1, 0}} )
   use srddtest alias orig
   append blank
   repla char1 with "One", char2 with "Rec1 long.." + space(284) + "..end"
   repla num1  with 1, num2 with 11111111111.111
   repla dat1  with date(), log1 with .T.

   append blank
   repla char1 with "Two-", char2 with "Rec2 long.." + space(284) + "..end"
   repla num1  with 222, num2 with -2222222222.222
   repla dat1  with date() +1, log1 with .F.

   skip 0

*   ? "an RTE (Exclusive lock failed...) should occur now"
endif

use srddtest new via smallRDD
? "--- step 1: command usage of the smallRDD driver"
? "used() :", used(), "alias=", Alias(), "WA=", select()
if used()
   while !eof()
      ? recno(), char1, num1, num2, dat1, log1
      skip
   enddo
   aeval (dbstruct(), {|x| qout(x[1], x[2], x[3], x[4])})
endif
goto 1

oUntyped := DBOBJECT()
? "--- step 2: untyped object usage of the smallRDD driver"
? "oUntyped:Used :", oUntyped:Used, "alias=", oUnTyped:Alias, "WA=", select()
if oUntyped:Used
   while ! oUntyped:eof
      ? oUntyped:recno, char1, num1, num2, dat1, log1
      oUntyped:skip()
   enddo
endif
* oUntyped:displayInstances(.T.)
use
? "oUntyped:Used :", oUntyped:Used

#include "smallRDD.fh"
local oTyped as smallRDD

? "--- step 3: typed object usage of the smallRDD driver"
oTyped := smallRDD {"srddtest"}
? "oTyped:Used :", oTyped:Used, "alias=", oTyped:Alias, "WA=", select()
if oTyped:Used
   while ! oTyped:eof
      ? oTyped:recno, char1, oTyped:num1, num2, oTyped:dat1, log1
      oTyped:skip()
   enddo
endif
oTyped:goto(1)
? "--- step 4: command usage of the typed RDD"
while !eof()
   ? recno(), char1, num1, num2, dat1, log1
   skip
enddo
? "--- step 5:"
aeval (oTyped:dbstruct(), {|x| qout(x[1], x[2], x[3], x[4])})

? "oTyped:Used :", oTyped:Used

