//begin arayconv.prg

// main section to read file line by line
#include "set.fh"
#include "inkey.fh"

static a 
parameters thefile

private allarays[2000], allwhere[2000], lastone, prglist[1000], numfiles, j

IF !FILE('./tmp')
  RUN ('mkdir ./tmp ; chmod 777 ./tmp')
ENDIF

// array pointer for allarays array
lastone=1

// read files according to the skeleton
IF LEN(ALLTRIM(thefile)) > 0
  numfiles=adir(thefile,prglist)
ELSE
  numfiles=adir("*.prg", prglist)
ENDIF

for j = 1 to numfiles
   a=readprg(prglist[j])
next

clear
for i = 1 to lastone-1
  ? allarays[i] + allwhere[i]
  if i/20 = int(i/20)
     inkey(0)
  endif
next

&&? a
a = INKEY(0)

// now read each program, and substitue each occurence of *(*) with *[*]
for j = 1 to numfiles
   a=writeprg(prglist[j])
next

return
********************************************************************
function readprg
********************************************************************
parameters theprg
static prgline, foffset, prglinlen, a, stripline
private i, filehdl
prgline=space(512)
foffset=0

// open the file
filehdl=fopen(theprg)
if ferror() != 0
   return 'Cannot open file '+ theprg
endif

// read each line until end of file is reached [a null is read]
fseek(filehdl,0)

for i = 1 to 1000000
   // line read
   prgline=freadstr(filehdl,512)

   // all done if a null is returned
   if len(prgline) = 0
      return 'Finished - Press Any Key To Continue'
   endif
   // where is end of line?
   prglinlen=at(chr(10),prgline)
   // what if there is no new-line char?
   if prglinlen = 0
      prglinlen := len(prgline)
   endif
   // increment the offset by the line len
   foffset:=foffset+prglinlen
   stripline=substr(prgline,1,prglinlen)
   stripline=strtran(stripline,chr(10))
   stripline=strtran(stripline,chr(13))

&&   @ 22,0 say 'offset:' + str(foffset) + ' file: '  + theprg + ' line: ' + str(i) + ' array # ' + str(lastone) + '       '
&&   @ 23,0 say space(80)
   
   if 'DIME'    $ substr(alltrim(upper(stripline)),1,4) .OR. ;
      'PUBLIC'  $ substr(alltrim(upper(stripline)),1,6) .OR. ;
      'PRIVATE' $ substr(alltrim(upper(stripline)),1,7) 

       do while .T.
	  if substr(alltrim(stripline),len(alltrim(stripline))) == ';'
	     fseek(filehdl,foffset,0)
	     // line read again and concatenated to previous line
	     prgline=freadstr(filehdl,512)
	     // all done if a null is returned
	     if len(prgline) = 0
		 return 'Finished - Press Any Key To Continue'
	     endif
	     // where is end of line?
	     prglinlen=at(chr(10),prgline)
	     // what if there is no new-line char?
	     if prglinlen = 0
		prglinlen := len(prgline)
	     endif
	     // increment the offset by the line len
	     foffset:=foffset+prglinlen
	     stripline=stripline+substr(prgline,1,prglinlen)
	     stripline=strtran(stripline,chr(10))
	     stripline=strtran(stripline,chr(13))
	 
	  else
	      exit
	  endif
       enddo
       // remove the semi-colons so they don't get included in the array name
       stripline=strtran(stripline,';')
       a=inkey()
       araylst(stripline)
   endif
   a=inkey()
   fseek(filehdl,foffset,0)

next
fclose(filehdl)
**************************************************************************
procedure araylst
**************************************************************************
parameters stripline
// remove the dim, pub, or priv stmt and re-trim the line....

stripline=ALLTRIM(stripline)
IF "&" $ UPPER(stripline)
  stripline=ALLTRIM(SUBSTR(UPPER(ALLTRIM(stripline)), AT("&", ALLTRIM(stripline)) + 1))
ELSE
  stripline=ALLTRIM(SUBSTR(UPPER(ALLTRIM(stripline)),AT(" ", ALLTRIM(stripline)) + 1))
ENDIF

while .T.
     if len(stripline) > 0
	 // extract the array name without the brackets
	 allarays[lastone]=alltrim(substr(stripline,1,at('(',stripline)-1))
	 allwhere[lastone]='  line ' + alltrim(str(i)) + '  prg: ' + alltrim(prglist[j])
		 // if commas, then more arrays
	 if ',' $ substr(stripline,at(')',stripline)+1)
                // prune the previous array from 'stripline'
	        // first take off the array itself: it may contain commas
	   stripline=substr(stripline,at(')',stripline)+1)
	        // then find the 1st comma after the array, and strip it.
	   stripline=alltrim(substr(stripline,at(',',stripline)+1))
	 else
		    // if no more commas, then no more arrays
	    stripline=''
	 endif
  	 if len(alltrim(allarays[lastone])) > 0
	    lastone=lastone+1
	 endif
	 else
	 return
     endif
enddo

return 'Finished - Press Any Key To Continue'
***************************************************************************
function writeprg
***************************************************************************
parameters theprg
private filerd, filewr, a, prgline, prglinelen, foffset
foffset=0

filewr:= fcreate('tmp/' + theprg)
if ferror() != 0
   return 'Cannot create output file '+ theprg
endif
filerd := fopen(theprg,0)
if ferror() != 0
   return 'Cannot open input file '+ theprg
endif

for i = 1 to 1000000
   
   // line read
   prgline=freadstr(filerd,512)
   // all done if a null is returned
   if len(prgline) = 0
      return 'Finished'
   endif
   // where is end of line?
   prglinlen=at(chr(10),prgline)
   // what if there is no new-line char?
   if prglinlen = 0
      prglinlen := len(prgline)
   endif
   // increment the offset by the line len
   foffset:=foffset+prglinlen
   // strip rest of info past end of line
   prgline=substr(prgline,1,prglinlen)
   // now transform all fox arrays into clipper arrays

   prgline=araytr(prgline)

&&   @ 22,0 say 'offset:' + str(foffset) + ' file: '  + theprg + ' line: ' + str(i) + '   '
&&   @ 23,0 say space(80)
&&   @ 23,0 say substr(prgline,1,prglinlen)

   a=fwrite(filewr,substr(prgline,1,prglinlen))
   if ferror() != 0
   	return 'Cannot write to output file '+ theprg
   endif
   
   a=inkey()
   fseek(filerd,foffset,0)

next
fclose(filerd)
fclose(filewr)
***************************************************************************
function araytr(line)
***************************************************************************
static linelen, begin, leftb, rightb, aname, setexact
aname=""
linelen=len(line)-1
begin=1
// loop to build array name
do while .T.
   // is there a '(' ?
   if at('(',substr(line,begin)) > 0
      // if so, build our potential array thing
      // this loop builds 1 string at a time.
     for i = 1 to begin
       if isalfanum(substr(line,begin-i,1)) .AND. ( begin -i > 0 )
         aname=upper(substr(line,begin-i,1)+aname)
       else
         exit
       endif
     next
   else
     // if no more brackets, get out and return to calling program
     exit
   endif
    // name has been built, now look for it in array
    // get the set exact setting...
    setexact=set(1) 
    set exact on
    if ascan(allarays,aname) > 0 .AND. len(alltrim(aname)) > 0
      // a match is found!, change left bracket
      line=stuff(line,begin,1,'[')
      // now find position of right bracket, and change it as well
      // find it by starting at left paren, and then finding 1st right paren
      rightb=at(')',substr(line,begin))+begin-1
      // is there another '(' nested in?
      otherb=at('(',substr(line,begin))+begin-1
      // if so, then look for the next closing paren
      // note: this only does 1 level nesting... ex: dimension array(recno())
      if otherb < rightb
        IF otherb + 1 = rightb
          rightb = rightb + 1
        ELSE
          rightb=at(')',substr(line,rightb))+rightb-1
        ENDIF
      endif
      line=stuff(line,rightb,1,']')
      // we now have changed this particular array!!!
    endif
    // increment line beginning! so we can look for second array, etc...
    if at('(',substr(line,begin+1)) > 0
      // if other paren, do this, else if no more, exit!
      begin=at('(',substr(line,begin+1))+begin
      // reset aname to null
      aname=''
    else 
      exit
    endif
enddo

a=set(1,setexact)
return line
********************************************************************
function isalfanum(string)
********************************************************************
if isalpha(string) .OR. isdigit(string) .OR. string+':' $ '_:'  
   return .T.
else
   return .F.
endif
return
********************************************************************
