//begin procfl.prg:

#include "stdfox.fh"
#include "box.fh"
#include "inkey.fh"
#include "achoice.fh"

***************************************************************
function wgsscat
***************************************************************
parameters thearray
private i,mwork
for i = 1 to 750
   store fieldname() to thearray[i,1],mwork
   if len(mwork) = 0
     return .T.
   endif
   thearray[i,2]=&mwork
next
return .F.
***************************************************************
function wgsgath
***************************************************************
parameters thearray
private i,mwork
for i = 1 to 750
   if len(thearray[i,1]) = 0
     return .T.
   endif
   mwork=thearray[i,1]
   replace &mwork with thearray[i,2]
next
return .F.
***************************************************************
FUNCTION fset_proff
do set_proff
return .T.
*****************************************************************
FUNCTION fset_prto
parameters mtemp
do set_prto with mtemp
return .T.
*****************************************************************
FUNCTION fset_dev
parameters mwhere
do set_dev with mwhere
return .T.
*****************************************************************
PROCEDURE set_proff
private mprstr
*
*fv mprfil can be in 2 forms:
*fv either a spooler name, or a FoxBase+ expression: 'cat | lp -s -dspool_nam'
*fv if the string 'lp' is found in mprinter, the latter is assumed.
*
if FILE(mprfil)
   if 'lp' $ mprinter
      mprstr='cat ' + mprfil + ' | ' + mprinter
   else
      mprstr='cat '+mprfil+' | '+ 'lp -s '+iif(len(alltrim(mprinter)) > 0,' -d'+mprinter,"")
   endif
   ! &mprstr
   mprstr='echo "\c" > '+mprfil
   ! &mprstr
endif
set print off
return
****************************************************************
PROCEDURE set_prto
parameters mtemp	&& use this PROC by sending a spooler name!
*fv 
*fv mtemp is the spooler destination
*fv ATTENTION:
*fv mprinter is a public var declared at program startup!!!
*fv 
store mtemp to mprinter
*fv this is the actual printer file for flagship
set printer to &mprfil
return
***************************************************************
PROCEDURE set_dev
parameters mwhere
do case
case upper(alltrim(mwhere)) = 'SCREEN'
   do set_proff
   set device to screen
case upper(alltrim(mwhere)) $ 'PRINTER'
   set device to printer
endcase
return
****************************************************************
FUNCTION nothing
return .T.
****************************************************************
FUNCTION brk(fn)

if pcount() = 0
  if len(alltrim(getenv('FSBRK'))) > 0
	fn=getenv('FSBRK')
  else
        return .F.
  endif
endif
return breakpoint(fn,0)
****************************************************************
//  To be the implementation of the FoxBase+ 
//  @ <coord1> MENU ... TITLE ...
/*
 nTop:      Top line of the menu box
 nLeft:     Left line of the menu box
 aArray:    Array of line items in the menu
 nMaxItems: Maximum number of items in the menu array
 nMaxDisp:  Maximum number of items to display at one time
 cTitle:    Title of the menu
*/
FUNCTION popmenu

PARAMETERS nTop,    nLeft,  aArray,  nMaxItems, nMaxDisp, cTitle  
PRIVATE    nBottom, nRight, nLine,   nLen,      nTemp,    nII

nLine := nTop + 2
nBottom := nLine + nMaxDisp + 2

nLen = 0
nTemp = 0

FOR nII = 1 TO nMaxItems
  nTemp := LEN(aArray[nII])
  IF nTemp != 0
    IF nTemp > nLen
      nLen := nTemp
    ENDIF
  ELSE
    nII := nMaxItems + 1
  ENDIF
NEXT

nLen := 20
nRight := nLeft + nLen + 2

&&? " nTop,    nLeft,  aArray,  nMaxItems, nMaxDisp, cTitle " 
&&? nTop,    nLeft,  aArray,  nMaxItems, nMaxDisp, cTitle  
&&?
&&? " nBottom, nRight, nLine,   nLen,      nTemp,    nII "
&&? nBottom, nRight, nLine,   nLen,      nTemp,    nII
&&INKEY(0)

@ nTop,    nLeft   CLEAR TO nBottom, nRight
@ nTop,    nLeft       TO nBottom, nRight DOUBLE
@ nLine,   nLeft + 1   TO nLine,   nRight - 1
@ nLine-1, nLeft+1 SAY      cTitle
SET WRAP ON
mcompno := ACHOICE(nLine+1, nLeft+1, nBottom-1, nRight-1, aArray, .T.)
RETURN mCompno
****************************************************************
//  To be the implementation of the FoxBase+ 
//  READ MENU BAR TO xpr1, xpr2 [SAVE]
//  [SAVE] keeps the menu onscreen after an item is selected.
/*
  nTitle:     The menu title to be used
  nBarPos:    The position where the highlight is to be placed  
*/
FUNCTION menubar
PARAMETERS nTitle, nBarPos
RETURN .T.
****************************************************************
FUNCTION InvalidKey(nStatus, nItem, nRelRow)
/*
*/
@ 24, 0 SAY "Invalid key was pressed.  Please try again."
RETURN .T.
****************************************************************
FUNCTION FoxScroll(nTop, nLeft, nBottom, nRight, nShift)
RETURN SCROLL(nTop, nLeft, nBottom, nRight, nShift)
****************************************************************
FUNCTION TestMacro(cMacro)
RETURN .T.
****************************************************************
FUNCTION AppMemo(MemField, cFile, cOverwrite)

LOCAL aTemp[1], aSize[1]
nCount := ADIR(cFile, aTemp, aSize)
IF nCount > 0
  ? "Cannot find file " , cFile
  RETURN
ENDIF

&& read the entire file to be appended to the memo field
cTemp := FREADSTR(cFile, aSize[1])
RLOCK()
IF UPPER(cOverwrite) == 'OVERWRITE'
  REPL MemField WITH cTemp
ELSE
  cTemp := MemField
  cTemp := ALLTRIM(cTemp) + SPACE(2) + FREADSTR(cFile, aSize[1])
  REPL MemField WITH cTemp  
ENDIF
UNLOCK
RETURN
****************************************************************
FUNCTION sys(nPar1, cPar2, cPar3)

PRIVATE cBuffer, nTmp, nHandle
DECLARE aTmp[ADIR("*")]
DO CASE
  CASE (nPar1) == 0
    cBuffer := SUBSTR(FS_SET("print"),2)
    nTmp := AT('.', cBuffer)
    cBuffer := SUBSTR(cBuffer, nTmp+1)
    RETURN (cBuffer)
  CASE (nPar1) == 1
    RETURN DTOS(DATE())
  CASE (nPar1) == 2
    RETURN SECONDS()
  CASE (nPar1) == 3
    cBuffer := ALLTRIM(FS_SET("print"))
    nII := 1
    DO WHILE .T.
      IF !FILE(cBuffer + '.' + ALLTRIM(STR(nII)))
        cBuffer := ALLTRIM(cBuffer) + '.' + ALLTRIM(STR(nII))
        RETURN cBuffer
      END
      nII++
    ENDDO
  CASE (nPar1) == 5
  CASE (nPar1) == 6
  CASE (nPar1) == 7
  CASE (nPar1) == 9
  CASE (nPar1) == 10
  CASE (nPar1) == 11
  CASE (nPar1) == 12
    RETURN MEMORY()
  CASE (nPar1) == 13
  CASE (nPar1) == 14
  CASE (nPar1) == 15
  CASE (nPar1) == 16
    RETURN PROCNAME(1)
  CASE (nPar1) == 17
  CASE (nPar1) == 18
  CASE (nPar1) == 21
  CASE (nPar1) == 30
    cBuffer := SPACE(30)
    nHandle := FCREATE("./idfile")
    RUN("id > ./idfile")
    FSEEK(nHandle, 0, FS-SET)
    cBuffer := FREADTXT(nHandle)
    nAT1 := AT('(', cBuffer)+1
    nAT2 := AT(')', cBuffer)-1
    cBuffer := ALLTRIM(SUBSTR(cBuffer, nAT1, nAT2 - nAT1 + 1))
    RETURN cBuffer
  CASE (nPar1) == 100
  CASE (nPar1) == 101
  CASE (nPar1) == 102
  CASE (nPar1) == 103
  CASE (nPar1) == 2000
  CASE (nPar1) == 2001
  CASE (nPar1) == 2002
    IF cPar2 != '1'
      SET CURSOR OFF
    ELSE
      SET CURSOR ON
    ENDIF
  CASE (nPar1) == 2003
    RETURN CURDIR()
  CASE (nPar1) == 2004
ENDCASE
****************************************************************
FUNCTION OnEscCmdKey(pXpr)

&&RETURN KEYBOARD(pXpr)
RETURN .T.
****************************************************************
FUNCTION OnEscCmdDo(pXpr)

&&IF pXpr == NIL
&&ELSE
&&  DO pXpr
&&ENDIF
RETURN NIL
****************************************************************
****************************************************************
****************************************************************
****************************************************************
****************************************************************
****************************************************************
****************************************************************
****************************************************************
****************************************************************
****************************************************************
