/*******************
* __Ffmath.prg
* Funciones matematicas
***************/
#include "FSextend.h"
/**************
* pi ()
*
**********************/
FSudfname (pi) {
  double retval = M_PI;
  FSinit();
  _retnd(retval);
  FSreturn;
}
/** eof **/
/**************
* sin(<numeric expresion>)
*
* numeric expresion is given in radians
**********************/
FSudfname (sin) {
  double degree, retval = 0.0;
  FSinit();
  if (PCOUNT == 1 && ISNUM(1)) {
      degree = _parnd (1);
      retval = sin (M_PI * degree / 180.0);
  }
  _retnd(retval);
  FSreturn;
}
/** eof **/


/**************
* cos(<numeric expresion>)
*
* numeric expresion is given in radians
**********************/
FSudfname (cos) {
  double degree, retval = 0.0;
  FSinit();
  if (PCOUNT == 1 && ISNUM(1)) {
      degree = _parnd (1);
      retval = cos (M_PI * degree / 180.0);
  }
  _retnd(retval);
  FSreturn;
}
/** eof **/
/**************
* asin(<numeric expresion>)
*
* numeric expresion is given in radians
**********************/
FSudfname (asin) {
  double degree, retval = 0.0;
  FSinit();
  if (PCOUNT == 1 && ISNUM(1)) {
      degree = _parnd (1);
      retval = asin (M_PI * degree / 180.0);
  }
  _retnd(retval);
  FSreturn;
}
/** eof **/


/**************
* acos(<numeric expresion>)
*
* numeric expresion is given in radians
**********************/
FSudfname (acos) {
  double degree, retval = 0.0;
  FSinit();
  if (PCOUNT == 1 && ISNUM(1)) {
      degree = _parnd (1);
      retval = acos (M_PI * degree / 180.0);
  }
  _retnd(retval);
  FSreturn;
}
/** eof **/
/**************
* tan(<numeric expresion>)
*
* numeric expresion is given in radians
**********************/
FSudfname (tan) {
  double degree, retval = 0.0;
  FSinit();
  if (PCOUNT == 1 && ISNUM(1)) {
      degree = _parnd (1);
      retval = tan (M_PI * degree / 180.0);
  }
  _retnd(retval);
  FSreturn;
}
/** eof **/
/**************
* atan(<numeric expresion>)
*
* numeric expresion is given in radians
**********************/
FSudfname (atan) {
  double degree, retval = 0.0;
  FSinit();
  if (PCOUNT == 1 && ISNUM(1)) {
      degree = _parnd (1);
      retval = atan (M_PI * degree / 180.0);
  }
  _retnd(retval);
  FSreturn;
}
/** eof **/
/**************
* atn2(<numeric expresion>)
*
* numeric expresion is given in radians
**********************/
FSudfname (atn2) {
  double x, y, retval = 0.0;
  FSinit();
  if (PCOUNT == 2 && ISNUM(1) && ISNUM(2)){
      y = _parnd (1);
      x = _parnd (2);
      retval = atan2 (M_PI * y / 180.0, M_PI * x / 180.0);
  }
  _retnd(retval);
  FSreturn;
}
/** eof **/
/**************
* log10(<numeric expresion>)
*
**********************/
FSudfname (log10) {
  double logar, retval = 0.0;
  FSinit();
  if (PCOUNT == 1 && ISNUM(1)) {
      logar  = _parnd (1);
      retval = log10 (logar);
  }
  _retnd(retval);
  FSreturn;
}
/** eof **/
/**************
* rand(<numeric expresion>)
*
**********************/
FSudfname (rand) {
  double retval = 0.0;
  double drand48();
  void srand48(long);
  unsigned int seed;
  FSinit();
  if (PCOUNT == 1 && ISNUM(1)) {
      srand48(_parni(1));
  }
  retval = drand48();
  _retnd(retval);
  FSreturn;
}
/** eof **/
/**************
* rtod(<numeric expresion>)
*
* numeric expresion is given in radians
**********************/
FSudfname (rtod) {
  double radian, degree = 0.0;
  FSinit();
  if (PCOUNT == 1 && ISNUM(1)) {
      radian = _parnd (1);
      degree = (M_PI * radian / 180.0);
  }
  _retnd(degree);
  FSreturn;
}
/** eof **/

/**************
* dtor(<numeric expresion>)
*
* numeric expresion is given in degrees
**********************/
FSudfname (dtor) {
  double radian = 0.0, degree;
  FSinit();
  if (PCOUNT == 1 && ISNUM(1)) {
      degree = _parnd (1);
      radian = (180.0 * degree / M_PI);
  }
  _retnd(radian);
  FSreturn;
}
/** eof **/
/**************
* ceiling(<numeric expresion>)
*
**********************/
FSudfname (ceiling) {
  double number, retval = 0.0;
  FSinit();
  if (PCOUNT == 1 && ISNUM(1)) {
      number  = _parnd (1);
      retval  = ceil (number);
  }
  _retnd(retval);
  FSreturn;
}
/** eof **/
/**************
* floor(<numeric expresion>)
*
**********************/
FSudfname (floor) {
  double number, retval = 0.0;
  FSinit();
  if (PCOUNT == 1 && ISNUM(1)) {
      number  = _parnd (1);
      retval  = floor (number);
  }
  _retnd(retval);
  FSreturn;
}
/** eof **/
