
/*
$Id: example0.prg,v 1.2 1997/09/30 04:45:38 catfood Exp catfood $

GENERATES MAIN MENU FOR EXAMPLE PROGRAMS

WebKit: CGI and FastCGI interface library for FlagShip
Copyright (C) 1996,1997   Mark W. Schumann <webkit@underflap.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$Log: example0.prg,v $
Revision 1.2  1997/09/30 04:45:38  catfood
Multiple fixes to bring us to WK release 1.02.

Revision 1.1  1997/09/26 01:47:52  catfood
Initial revision


*/

#include "webkit.fh"

#define DATA "/usr/local/webkit/examples"

request errhand

function webkitmain (aEnv as array, aForm as array, oState as usual) as usual
local cExample as string

set (_SET_DEFAULT,   DATA)
_setdir (DATA)
cExample := wklookup (aEnv, "QUERY_STRING")
if empty (cExample)
	cExample := strtran (wklookup (aEnv, "PATH_INFO"), "/", "")
endif

do case
	case cExample == "example0"
		example0 (aEnv, aForm, oState)
	case cExample == "example1"
		example1 (aEnv, aForm, oState)
	case cExample == "example2"
		example2 (aEnv, aForm, oState)
	case cExample == "example3"
		example3 (aEnv, aForm, oState)
	case cExample == "example4"
		example4 (aEnv, aForm, oState)
	case cExample == "example5"
		example5 (aEnv, aForm, oState)
	case cExample == "example6"
		example6 (aEnv, aForm, oState)
	otherwise
		example0 (aEnv, aForm, oState)
endcase

return nil

function example0 (aEnv, aForm)

? "<HTML>"
? "<TITLE>WebKit programs</TITLE>"
? "<BODY>"
? "<H4>Copyright &copy; 1996, 1997, Mark W. Schumann</H4>"
? "<H1>Webkit demo programs</H1>"
?
? "<HR>"
? "Shortcuts:<br>"
? "<ol>"
? "<li><a href=#example1>Example 1</a><br>"
? "<li><a href=#example2>Example 2</a><br>"
? "<li><a href=#example3>Example 3</a><br>"
? "<li><a href=#example4>Example 4</a><br>"
? "<li><a href=#example5>Example 5</a><br>"
? "<li><a href=#example6>Example 6</a><br>"
? "</ol>"
?
? "<HR>"
? "<A NAME=example1>"
? "<H1>Example 1</H1>"
? "<A HREF=" + exlink (1) + " METHOD=POST>Look at</A>"
? "your CGI environment variables and form variables.  (You"
? "won't actually have any form variables because this example is invoked"
? "without a &lt;FORM&gt tag.)"
?
? "<HR>"
? "<A NAME=example2>"
? "<FORM ACTION=" + exlink (2) + " METHOD=POST>"
? "<H1>Example 2</H1>"
? "This is a sample registration type of form.  Obviously you can add"
? "more fields and do a lot more processing than in the example here."
? "<P>"
? "Please enter your name:<BR>"
? "First: <INPUT TYPE=TEXT NAME=FIRSTNAME SIZE=20><BR>"
? "Middle: <INPUT TYPE=TEXT NAME=MIDDLENAME SIZE=20><BR>"
? "Last: <INPUT TYPE=TEXT NAME=LASTNAME SIZE=20><BR>"
? "<INPUT TYPE=SUBMIT VALUE=Register><BR>"
? "<INPUT TYPE=SUBMIT VALUE=Reset><BR>"
? "</FORM>"
?
? "<HR>"
? "<A NAME=example3>"
? "<FORM ACTION=" + exlink (3) + " METHOD=POST>"
? "<H1>Example 3</H1><BR>"
? "This is a typical lookup using DBSEEK().  Nothing fancy."
? "<P>"
? "Account Number: <INPUT TYPE=TEXT NAME=ACCOUNT SIZE=20><BR>"
? "<INPUT TYPE=SUBMIT VALUE=Lookup>"
? "</FORM>"
?
? "<HR>"
? "<A NAME=example4>"
? "<H1>Example 4</H1>"
? "Here's how you might display a picklist from a database."
? "<P>"
? "Display a list of "
? "<A HREF=" + exlink (4) + ">URLs</A>"
? " right here."
?
? "<HR>"
? "<A NAME=example5>"
? "<H1>Example 5</H1>"
? "This form and the code behind are incomplete, but you can see how"
? "an interactive sequence might be made by reading the code in"
? "example5.prg.  For a future project I'm working on giving this"
? "a snazzy Java front end, too."
? "<A HREF=" + exlink (5) + ">Try it!</A>"
?
? "<HR>"
? "<H1>Example 6</H1>"
? "This is another incomplete example.  It uses Netscape-style table"
? "output to give the effect of a database browser.  It's hardcoded"
? "to use the users.dbf that is set up in Example 2 and searched in"
? "Example 3."
? "<A HREF=" + exlink (6) + ">Try it!</A>"
?
? "</BODY>"
? "</HTML>"

return nil

function exlink (nExampleNum)
local cReturn as string

cReturn := "/cgi-bin/example0"
if fastcgi()
	cReturn += ".fcgi"
endif
cReturn += "/example" + ltrim (str (nExampleNum))
return cReturn

// enable if required, i.e. when the linker reports problems
// and enable the -DUSEOWNINIT in Makefile
// 
// FUNCTION programini
//   CALL fgsUse4html
// return NIL

