/*

USER-LEVEL FUNCTIONS FOR HTML OUTPUT

$Id: wkfunc.prg,v 1.2 1997/09/30 04:45:38 catfood Exp catfood $

WebKit: CGI and FastCGI interface library for FlagShip
Copyright (C) 1996,1997   Mark W. Schumann <webkit@underflap.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$Log: wkfunc.prg,v $
Revision 1.2  1997/09/30 04:45:38  catfood
Multiple fixes to bring us to WK release 1.02.

Revision 1.1  1997/09/26 01:47:52  catfood
Initial revision


*/

#include "webkit.fh"

// For FS release older than 4.42.448, avoid 
// unresolved external 'fgsUse4html'
#ifdef FS440
#Cinline
   void fgsUse4html() 
   {};
#endCinline
#endif

FUNCTION wkhtml (cpTitle)
? "<HTML>"
IF VALTYPE (cpTitle) == "C"
    ? "<TITLE>" + cpTitle + "</TITLE><BR>"
ENDIF
RETURN .T.

FUNCTION wkbody
? "<BODY>"
return .t.

FUNCTION wkhtmlend
? "</HTML>"
return .t.

FUNCTION wkbodyend
? "</BODY>"
return .t.

FUNCTION wkem (s)
? "<EM>" + s + "</EM>"
return .t.

FUNCTION wkhrule
? "<HR>"
return .t.

FUNCTION wkline (s)
IF VALTYPE (s) != 'C'
	s := ""
ENDIF
? s + "<BR>"
return .t.

FUNCTION wklist (aItems, lOrdered)
LOCAL_INT i
DEFAULT lOrdered TO .F.
? IIF (lOrdered, "<OL>", "<UL>")
FOR i := 1 TO LEN (aItems)
	? "<LI>" + aItems[i]
NEXT
? IIF (lOrdered, "</OL>", "</UL>")
return .t.

FUNCTION wktable (a2Items, cCaption)
LOCAL_INT i
LOCAL_INT j
IF cCaption == NIL
	? "<TABLE>"
ELSE
	? "<TABLE CAPTION='" + cCaption + "'>"
ENDIF

FOR i := 1 TO LEN (a2Items)
	? "<TR>"
	FOR j := 1 TO LEN (a2Items[i])
		? "<TD>" + a2Items[i][j] + "</TD>"
	NEXT
	? "</TR>"
NEXT
? "</TABLE>"
return .t.

FUNCTION wklink (cLinkURL, cLinkDesc)
?? '<A HREF="' + cLinkURL + '">' + cLinkDesc + '</A>'
return .t.

FUNCTION wkimage (cImage, cAltDesc, cAlign)
DEFAULT cAltDesc TO "[image here]"
?? '<IMG="' + cImage + '" ALT="' + cAltDesc + '">'
return .t.

FUNCTION wklookup (aList, cTarget)
LOCAL_INT n
cTarget := ALLTRIM (UPPER (cTarget))
n := ASCAN (aList, {|z| z[1] == cTarget})
RETURN IIF (n > 0, aList[n,2], "")

