/****************************************************************************
 * FlagShip Header File                                                     *
 *                                                                          *
 * Release 4.48 from 06/2001                                                *
 *--------------------------------------------------------------------------*
 * (c) 1996 multisoft Datentechnik GmbH, Munich. All rights reserved.       *
 ****************************************************************************/

#ifndef   __FGS_FLAGSHIP__
#  define __FGS_FLAGSHIP__

#if   defined (FGS_INTERACTIVE) \
   || defined(FGSAVIION)        \
   || defined(FGSM6832)         \
   || defined(FGSMV8832)        \
   || defined(FGSNSCSinix)      \
   || defined(FGSSUNOS)         \
   || defined(FGSEURIX)         \
   || ( defined(FGSHPUX) && !defined(FGSHPUX11) )
# define FGS_ANSI(x) ()
#else
# define FGS_ANSI(x) x
#endif

#if   defined (FGS_INTERACTIVE) \
   || defined(FGSAVIION)        \
   || defined(FGSM6832)         \
   || defined(FGSMV8832)        \
   || defined(FGSNSCSinix)      \
   || defined(FGSSUNOS)         \
   || defined(FGSEURIX)         \
   || ( defined(FGSHPUX) && !defined(FGSHPUX11) )
# define _FGS_CCNAME_CONV2
#else
#endif

#if defined (FGSSINIXRM545)
#   define _FGS_EXTERN_EXTERN
#endif

#if defined(FGSLINUXMIPS)
# define FGS_STDARGS_PROTO
#endif                                                                                            

#if defined(FGSAIX)
#   include <cur00.h>
#   include <cur02.h>
#else
# if defined(FGSLINUX)
#   if defined(FGSLINUXELF)
#     include <ncur194/curses.h>
#   else
#     include <ncur181/curses.h>
#   endif
# else
#   if defined(FGSHPUX11)
#      include <sys/termio.h>
#      include <curses_colr/curses.h>
#   else
#      include <curses.h>
#   endif
# endif
#endif

#ifndef FGS_PROTOCURSES
# if defined(FGSHPUX) && !defined(FGSHPUX11)  
#   define FGS_PROTOCURSES
# endif
# if defined(FGSAIX) && !defined(FGSncurses)
#   define FGS_PROTOCURSES
# endif
# if defined(FGSTru64) && !defined(FGSncurses)
#    define FGS_PROTOCURSES
# endif
#endif

#include <sys/types.h>
#include <unistd.h>
#include <setjmp.h>
#include <ctype.h>
#include <math.h>

#define IBM_COLORS

#define BELL    7
#define BS      8
#define TAB     9
#define LF      10
#define NL      10
#define CR      13
#define ESC     27
#define FF      12

#ifndef TRUE
#   define TRUE    1
#endif
#ifndef FALSE
#   define FALSE   0
#endif

#ifndef ON
#   define ON       1
#endif
#ifndef OFF
#   define OFF      0
#endif

#define EXPLEN 4096         /* expressio length as defined in exp_eval      */


/* ---------------- Types to be used in normal programming ---------------- */

#define _FS_TYPEDEFS_

#if defined(FGSDECAlpha) 
# if !defined(FGSTru64)
#   define long int
# else
#   define FGS_LONG64
# endif
#endif

typedef short           FSshort  ;
typedef unsigned short  FSushort ;
typedef int             FSint    ;
typedef unsigned int    FSuint   ;
typedef long            FSlong   ;
typedef unsigned long   FSulong  ;
typedef char            FSchar   ;    /* signed character type (unused ?)   */
typedef unsigned char   FSuchar  ;    /* normal character type              */
typedef float           FSfloat  ;    /* short double value   (unused ?)    */
typedef double          FSdouble ;    /* normal double value                */
typedef void            FSvoid   ;    /* void type                          */
typedef void *          FSvoidptr;    /* void ptr, pointer to nothing       */

typedef char            FsDbfChar ;   /* must be 1 byte  */
typedef unsigned char   FsDbfUchar ;  /* must be 1 byte  */
typedef short           FsDbfShort;   /* must be 2 bytes */
typedef unsigned short  FsDbfUshort;  /* must be 2 bytes */
typedef int             FsDbfInt  ;   /* must be 4 bytes */
typedef unsigned int    FsDbfUint ;   /* must be 4 bytes */
typedef double          FsDbfDouble;  /* must be 8 bytes */

#ifdef FGS_LONG64
  typedef int           FsDbfLong;    /* must be 4 bytes */
  typedef unsigned int  FsDbfUlong;   /* must be 4 bytes */
#else
  typedef long          FsDbfLong;     
  typedef unsigned long FsDbfUlong;    
#endif

typedef off_t FsDbfOff_t;        /* for lseek */

#ifndef FSvar
#   define FSvar variable
#endif

#ifndef byte
#   define byte FSuchar
#endif

#ifndef word
#   define word FSushort
#endif

#ifndef dword
#   define dword FSuchar
#endif

/*  Special Key Codes as for Clipper                                        */
#define RightArrow      4
#define LeftArrow       19
#define UpArrow         5
#define DownArrow       24
#define CtrlRightArrow  2
#define CtrlLeftArrow   26
#define Ins             22
#define Del             7
#define Home            1
#define End             6
#define PgUp            18
#define PgDn            3
#define CtrlHome        29
#define CtrlEnd         23
#define CtrlPgUp        31
#define CtrlPgDn        30
#define Help            28
#define Backspace       8
#define Return          13


/*  -------------- structure for handling working areas ------------------- */

typedef struct fgsWorkArea
{
	FSuchar              cFlags;
	FSuchar              iLinks;
	FSushort		     iNumber;
	FSchar			   * cAlias;
	struct mv_data	   * oObject;
	struct mv_data	   * (* fpQuickGetMethod)();
	struct mv_data	   * (* fpQuickSetMethod)();
	struct fgsWorkArea * oNext;
} fgsWorkArea;

extern FSchar ** fgsKnownAlias;

/*  ------------------ structure defining memory variable ----------------- */

struct array_stru {
    FSushort links;
    FSushort component_count;
    struct mv_data **components;
};


struct mv_data {
    FSchar type;                    /* var type C, N, D, L, A, S, b, B, O, i*/
    FSchar mode;                    /*  C - constant always user&privelidged*/
                                    /*  F - field, mode const, spec. handlin*/
                                    /*  L/l - normal soft local (in cb's)   */
                                    /*  N/n - normal                        */
                                    /*  M/m - unassignable                  */
                                    /*  P/p - permanent (const) in user mode*/
                                    /*  S/s - fixed type                    */
                                    /*  T/t - temporary                     */
                                    /*  U - never defined.                  */
                                    /*  V/v - normal passed by value        */
                                    /* In case of lowercase, the variable   */
                                    /* contains a string constant not to be */
                                    /* released via free                    */
    FSuchar  dec;                   /* number of decimal places             */
    FSuchar  reserved;
    FSlong   len;                   /* total nuber of bytes occupied by var */
    FSushort links;                 /* no of logical links from names       */
    FSushort fldidx;                /* field ordinal/index                  */
                                    /* or index in var table for autoprivate*/
	union 
	{
		fgsWorkArea  * w_area;      /* working area in case of field var.   */
        FSint          decl_depth;  /* depth of declaration when var        */
	} fov;
 
    union {
        FSdouble  fnum;             /* float number value                   */
        FSint     inum;             /* integ number value                   */
        FSlong    date;             /* date (converted to long int) value   */
        FSuchar * chr;              /* pointer to character string buffer   */
        WINDOW  * scr;              /* screen variable holder pointer       */
		struct {
			struct array_stru *buff;      /* array vars (references in cb)  */
			struct mv_data * (* block)(); /* codeblock (function pointer)   */
		} cb;
		struct 
		{
			FSlong  val1;
			FSshort val2;
			FSshort val3;
		} gp;
		void *intern_data;                /* internal FS data storage       */
    } val;
};

typedef struct mv_data FSvar;


struct mv_name {        /* structure for array of mem var names             */
    FSuchar             name[11];     /* variable name (10 chars + 0 del.)  */
    FSulong             next;         /* next mem var name in linked list   */
    struct array_stru * f;            /* pointer to array of field vars     */
    FSvar             * v;            /* pointer to actual variable struct  */
};

extern struct mv_name *mv_names;

extern FSvar *NIL_VAR,   *NULLSTR_VAR, *NULLDATE_VAR, *TRUE_VAR, *FALSE_VAR;
extern FSvar *ERROR_VAR, *ZERO_VAR,    *ONE_VAR,      *MINONE_VAR; 
extern FSvar *TRUCB_VAR, *NILCB_VAR,   *IZERO_VAR;

extern FSint glob_depth;


/*  ------ structure keeping info for known alias names -----------------   */

struct f_ali_tab {
    FSchar * name;                  /* pointer to alias name                */
    FSint  * idx;                   /* index in known alias table           */
};

struct g_ali_tab {
    FSchar identifier[12];
    struct f_ali_tab *f_ali_tab;
};

/*  ------ structure keeping info for user defined functions  -----------   */

typedef struct f_sym_tab {
    FSchar * name;                  /* pointer to function name             */
    FSvar  * (*ptr)();              /* function module address              */
} f_sym_tab;

typedef struct g_sym_tab {
    FSchar identifier[12];
    f_sym_tab *f_sym_tab;
} g_sym_tab;

/* ------- structure for locating a single fun to be accessable by macro -- */
struct fsuFuncLocate
{
   FSchar     f_locator[12];
   FSchar   * f_name;
   FSvar    * (* f_ptr)();
};

/*  ------ structure keeping info for user defined variables  -----------   */

struct f_deb_tab {
    FSchar    * name;               /* pointer to variable name             */
    FSvar    ** idx;                /* variable structure                   */
};

struct f_var_tab {
    FSchar * name;                  /* pointer to variable name             */
    FSint  * idx;                   /* variable structure index             */
};

struct g_var_tab {
    FSchar identifier[12];
    struct f_var_tab *f_var_tab;
};

/*  ----- data structure keeping statuses of HW and SW environment ------   */

struct status {
    FSchar color,
         debugger,
         deb_stat,
         read_ex,
         read_ins,
         cancel;
};


/*  ------------------------ function stack ------------------------------  */

typedef struct fn_stack         /* one function stack entry                 */
{
    FSlong    lin_no;           /* line # in current function               */
    FSlong    tmv_now;          /* temporary variables for deletion mark    */
    FSlong    tmv_all;          /* temporary variables for deletion mark    */
    FSlong    seq_var_stack;    /* vars on stack for del. after BREAK mark  */
    FSlong    localupto;        /* variables on stack for deletion  mark    */
    FSvar   * rvalptr;          /* current return value                     */
    FSchar  * prg_name;         /* name of the prg where function is exec.  */
    FSchar  * module_name;      /* name of the current function             */
    FSshort   old_depth;        /* call depth -1 for this function          */
    FSshort   no_of_parameters; /* # of params passed in the cur. invocation*/
    struct fn_stack  * old_fn_stack;/* backward ptr, stacking for gl. ref   */
    struct f_deb_tab * deb_info1;  /* debugger func local/statics table     */
    struct f_deb_tab * deb_info2;  /* debugger file statics table           */
	FSint     inh_level;        /* inheritance level for methods,
								   super determination                      */
} fn_stack;

extern fn_stack *old_fn_stack;          /* function stack pointer of the    */
                                        /* calling function                 */

/*  ------------------------ objects structres ---------------------------  */

typedef struct xObject
{
	FSchar * pacName;
	FSint    iPosition;
	FSint    iLevel;
	FSint    iWhat;
} xObject;


/*  ------------------------ compiler data -------------------------------  */

extern FSchar * __main_module;  /* name of the main user module to start    */

extern FSuchar __core;          /* wether to trap seg.viol. signal or not   */

extern FSint __parc, __parc1;   /* parameter counters and parameter arrays  */

extern void *glob_sequencebuf;  /* long jump struct for BEGIN SEQUENCE END  */

extern FSint _sstep;            /* SINGLE STEP breakpoint flag              */

extern FSlong cur_var_stack;    /* counter to the top of the variable stack */

extern FSulong tmpvar_cnt;      /* temp vars counter                        */

extern struct status __status;  /* structure for status flags               */

extern FSint _tmp_1_, _tmp_2_;  /* temporaries during execution             */
extern FSvar *_vtmp_1_;      /* temporary variables during execution     */

extern FSchar repdum[];         /* temporary scratch pad                    */

extern FSint fgs_fs440;         /* current version allowed with this comp.  */

extern FSvar *(*fgs_subscarr)();  /* function for array of subscripts    */


/*  ------------------------ functions called from the Open C API --------- */

extern FSvar * fgsMakeCB   FGS_ANSI((FSchar *));

/* -------- determine and specify if long long AND llseek() is available ---
 * FS_HAS_LONGLONG 1 = offset_t   llseek (fd, offset_t offll, int whence);
 * FS_HAS_LONGLONG 2 = int       _llseek (fd, ulong offhi, ulong offlow, loff_t *result, int whence);
 * FS_HAS_LONGLONG 3 = __int64 _lseeki64 (fd, __int64 offset, int whence);
 * ------------------------------------------------------------------------- */
#ifndef FS_HAS_LONGLONG
# if defined(SUNsolaris) || defined(FGSAIX)
#  define FS_HAS_LONGLONG 1   /* std Unix */
# elif defined (FGSLINUX)
#  define FS_HAS_LONGLONG 2   /* Linux specific */
# elif defined(WIN32)
#  define FS_HAS_LONGLONG 3   /* Win32 specific */
# endif
#endif

#if defined(FGSAIX) || defined(SUNsolaris)  || defined(FGSLINUX)
# define FS_HAS_USLEEP_MS
#endif

#if defined(FGSAIX)
# define FS_HAS_GETTIMEOFDAY
#endif
#if defined(WIN32)
# define FS_HAS_GETLOCALTIME
#endif

/*  ------------------------ functions called by compiled prg code -------- */

extern FSvar *fgs_docall();
extern FSchar     *fgs_fn_start();
extern FSchar     *m_ex_c();
extern FSint      fgs_declare();
extern FSint      fgs_macro_declare();
extern FSint      fgs_macro_public();
extern FSint      fgs_public();
extern FSint      if_u();
extern FSulong fgs_ctod();
extern FSvar *autodec_u();
extern FSvar *autoinc_u();
extern FSvar *c_add_u();
extern FSvar *c_eequ_u();
extern FSvar *c_equ_c();
extern FSvar *c_equ_u();
extern FSvar *c_geq_c();
extern FSvar *c_geq_u();
extern FSvar *c_gt_c();
extern FSvar *c_gt_u();
extern FSvar *c_in_u();
extern FSvar *c_leq_c();
extern FSvar *c_leq_u();
extern FSvar *c_lt_c();
extern FSvar *c_neq_c();
extern FSvar *c_neq_u();
extern FSvar *cpy_var();
extern FSvar *cpy_varf();
extern FSvar *cpy_varff();
extern FSvar *cpy_varfv();
extern FSvar *cpy_varpf();
extern FSvar *cpy_varpv();
extern FSvar *cpy_varv();
extern FSvar *cpy_varvf();
extern FSvar *cpy_varvv();
extern FSvar *cre_arra();
extern FSvar *cre_tmpvar();
extern FSvar *c_sub_u();
extern FSvar *d_equ_u();
extern FSvar *d_geq_u();
extern FSvar *dget_arr();
extern FSvar *dget_arrv();
extern FSvar *d_gt_u();
extern FSvar *d_leq_u();
extern FSvar *d_lt_u();
extern FSvar *d_neq_u();
extern FSvar *exp_eval();

#ifdef FGS_STDARGS_PROTO
extern FSvar * cre_arr  (FSvar *, int, int, ...);
extern FSvar * set_bvar (FSvar *,FSvar *(*)(),int,...);
#else
extern FSvar *cre_arr();
extern FSvar *set_bvar();
#endif

extern FSchar      * fgs_chararg          FGS_ANSI((FSvar *, FSchar *));
extern FSvar       * fgsAddMethod         FGS_ANSI((FSvar *, FSint, FSvar *(*)(), FSint));
extern FSchar      * fgsCMxC              FGS_ANSI((FSchar *     , FSint   ));
extern FSvar       * fgsCMxV              FGS_ANSI((FSchar *     , FSint   ));
extern FSvar       * fgsDoInstance        FGS_ANSI((FSvar *, FSchar *, FSint, FSint, FSvar *));
extern FSvar       * fgsDoInit            FGS_ANSI((FSvar *, FSint, FSvar *[]));
extern FSvar       * fgsDoMethod          FGS_ANSI((FSchar *, FSint, FSint, FSint, FSvar *[]));
extern FSvar       * fgsDoSpecial         FGS_ANSI((FSvar *, FSint, FSint, FSint, FSint));
extern FSvar	   * fgsGetAliasCField    FGS_ANSI((fgsWorkArea *, FSchar *));
extern FSvar	   * fgsGetAliasField     FGS_ANSI((fgsWorkArea *, FSint   ));
extern FSvar	   * fgsGetAliasVar       FGS_ANSI((fgsWorkArea *          ));
extern FSvar	   * fgsGetCAliasCField   FGS_ANSI((FSchar *     , FSchar *));
extern FSvar	   * fgsGetCAliasField    FGS_ANSI((FSchar *     , FSint   ));
extern FSvar	   * fgsGetCField         FGS_ANSI((FSchar *               ));
extern FSvar       * fgsGetField          FGS_ANSI((FSint                  ));
extern FSvar       * fgsGetIAliasCField   FGS_ANSI((FSint        , FSchar *));
extern FSvar       * fgsGetIAliasField    FGS_ANSI((FSint        , FSint   ));
extern FSvar       * fgsGetLHSVar         FGS_ANSI((FSchar *               ));
extern FSvar       * fgsGetMemVar         FGS_ANSI((FSchar *               ));
extern FSvar       * fgsGetNAliasCField   FGS_ANSI((FSint        , FSchar *));
extern FSvar       * fgsGetNAliasField    FGS_ANSI((FSint        , FSint   ));
extern FSvar       * fgsGetVAliasCField   FGS_ANSI((FSvar *      , FSchar *));
extern FSvar       * fgsGetVAliasField    FGS_ANSI((FSvar *      , FSint   ));
extern FSvar       * fgsGetVar            FGS_ANSI((FSint                  ));
extern FSint         fgsIntVar            FGS_ANSI((FSvar *));
extern FSint         fgsLogVar            FGS_ANSI((FSvar *));
extern FSvar       * fgsNoDoMethod        FGS_ANSI((FSchar *, FSint, FSint, FSvar *[]));
extern FSvar       * fgsNoDoMacroMethod   FGS_ANSI((FSchar *, FSint, FSint, FSvar *[]));
extern FSvar       * fgsNoIVar            FGS_ANSI((FSvar *, FSchar *, FSint, FSvar*));
extern FSdouble      fgsNumVar            FGS_ANSI((FSvar *));
extern FSchar      * fgsVMxC              FGS_ANSI((FSvar *      , FSint   ));
extern FSvar       * fgsVMxV              FGS_ANSI((FSvar *      , FSint   ));
extern fgsWorkArea * fgsPopArea			  FGS_ANSI((fgsWorkArea *          ));
extern fgsWorkArea * fgsPushArea		  FGS_ANSI((fgsWorkArea *          ));
extern fgsWorkArea * fgsPushCArea		  FGS_ANSI((FSchar *               ));
extern fgsWorkArea * fgsPushIArea		  FGS_ANSI((FSint                  ));
extern fgsWorkArea * fgsPushNArea		  FGS_ANSI((FSint                  ));
extern fgsWorkArea * fgsPushVArea		  FGS_ANSI((FSvar *                ));
extern FSvar       * fgsSetDefault		  FGS_ANSI((FSvar *, FSint, FSchar, FSvar *));
extern FSvar       * set_Ov               FGS_ANSI((FSint, xObject [], FSvar *));
extern FSvar       * set_Iv               FGS_ANSI((FSint));
extern FSvar       * set_Ivar             FGS_ANSI((FSvar *, FSint));
extern FSvar       * set_Ivarv            FGS_ANSI((FSint, FSint));
extern FSvar       * set_Ivarf            FGS_ANSI((FSint, FSint));
extern FSvar       * fgs_fn_end           FGS_ANSI((fn_stack *, FSchar));

extern FSvar    * fgs_local_param 	FGS_ANSI((int, int, FSvar *[], FSchar));
extern FSvar *get_arr();
extern FSvar *get_field();
extern FSvar *get_macroid();
extern FSvar *get_vfield();
extern FSvar *(*instance_fun())();
extern FSvar *(*instance_macrofun())();
extern FSvar *instance_macrovar();
extern FSvar *instance_var();
extern FSvar *l_and_u();
extern FSvar *l_equ_u();
extern FSvar *l_geq_u();
extern FSvar *l_gt_u();
extern FSvar *l_leq_u();
extern FSvar *l_lt_u();
extern FSvar *l_neq_u();
extern FSvar *l_or_u();
extern FSvar *(*macrofun())();
extern FSvar    * mak_var        FGS_ANSI((char, char));
extern FSvar *minus_u();
extern FSvar *mk_var_cp();
extern FSvar *n_add_u();
extern FSvar *n_div_u();
extern FSvar *n_equ_u();
extern FSvar *n_geq_u();
extern FSvar *n_gt_u();
extern FSvar *n_leq_u();
extern FSvar *n_lt_u();
extern FSvar *n_mod_u();
extern FSvar *n_mul_u();
extern FSvar *n_neq_u();
extern FSvar *not_u();
extern FSvar *n_pow_u();
extern FSvar *n_sub_u();

extern FSvar *set_Cvar();
extern FSvar *set_Ivar();
extern FSvar *set_Svar();

extern FSvar *set_cvar();
extern FSvar *set_cvarf();
extern FSvar *set_cvarv();
extern FSvar *set_cv();
extern FSvar *set_dvar();
extern FSvar *set_dvarf();
extern FSvar *set_dvarv();
extern FSvar *set_dv();
extern FSvar *set_lvar();
extern FSvar *set_lvarf();
extern FSvar *set_lvarv();
extern FSvar *set_lv();
extern FSvar *set_nvar();
extern FSvar *set_nvarf();
extern FSvar *set_nvarv();
extern FSvar *set_nv();
extern FSvar *set_svar();

extern FSvar *u_add_c();
extern FSvar *u_add_u();
extern FSvar *u_and_u();
extern FSvar *u_autodec();
extern FSvar *u_autoinc();
extern FSvar *u_div_n();
extern FSvar *u_div_u();
extern FSvar *u_eequ_u();
extern FSvar *u_equ_c();
extern FSvar *u_equ_u();
extern FSvar *u_geq_c();
extern FSvar *u_geq_u();
extern FSvar *u_gt_c();
extern FSvar *u_gt_u();
extern FSvar *u_in_c();
extern FSvar *u_in_u();
extern FSvar *u_leq_c();
extern FSvar *u_leq_u();
extern FSvar *u_lt_c();
extern FSvar *u_lt_u();
extern FSvar *u_mod_n();
extern FSvar *u_mod_u();
extern FSvar *u_mul_u();
extern FSvar *u_neq_c();
extern FSvar *u_neq_u();
extern FSvar *u_or_u();
extern FSvar *u_pow_n();
extern FSvar *u_pow_u();
extern FSvar *u_sub_c();
extern FSvar *u_sub_n();
extern FSvar *u_sub_u();
extern void     _debugger();
extern void     _debugsrc();
extern void     _fgs_signal_n();
extern void     _fgs_signal_l();
extern void     _fgs_signal_d();
extern void     _fgs_signal_a();
extern void     del_tmpvars();
extern void     del_var();
extern void     fgs_after_break();
extern void     fgs_cleanup();
extern void     fgs_macro_param();
extern void     fgs_private_param();
extern void     fs_break_error();

extern FSdouble get_nvar(); /* <<< to be removed !!! */

/*  ------------------------ color handling ------------------------------- */

#ifndef COLOR_BLACK
#   define FGS_CURSES_DEFS
#   define COLOR_BLACK        0
#   define COLOR_RED          1
#   define COLOR_GREEN        2
#   define COLOR_YELLOW       3
#   define COLOR_BLUE         4
#   define COLOR_MAGENTA      5
#   define COLOR_CYAN         6
#   define COLOR_WHITE        7
#endif

#ifdef IBM_COLORS
#   define FS_COLOR_BLACK     COLOR_BLACK
#   define FS_COLOR_RED       COLOR_RED
#   define FS_COLOR_GREEN     COLOR_GREEN
#   define FS_COLOR_YELLOW    COLOR_YELLOW
#   define FS_COLOR_BLUE      COLOR_BLUE
#   define FS_COLOR_MAGENTA   COLOR_MAGENTA
#   define FS_COLOR_CYAN      COLOR_CYAN
#   define FS_COLOR_WHITE     COLOR_WHITE
#else
#   define FS_COLOR_BLACK     0
#   define FS_COLOR_RED       4
#   define FS_COLOR_GREEN     2
#   define FS_COLOR_YELLOW    6
#   define FS_COLOR_BLUE      1
#   define FS_COLOR_MAGENTA   5
#   define FS_COLOR_CYAN      3
#   define FS_COLOR_WHITE     7
#endif

#endif
/*** EOF FlagShip.h ***/
